<?php

//Carousels

if(!function_exists('kudos_qodef_map_carousel')) {
    function kudos_qodef_map_carousel() {

        $carousel_meta_box = kudos_qodef_add_meta_box(
            array(
                'scope' => array('carousels'),
                'title' => esc_html__('Carousel', 'kudos'),
                'name' => 'carousel_meta'
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_carousel_image',
                'type' => 'image',
                'label' => esc_html__('Carousel Image', 'kudos'),
                'description' => esc_html__('Choose carousel image (min width needs to be 215px)', 'kudos'),
                'parent' => $carousel_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_carousel_hover_image',
                'type' => 'image',
                'label' => esc_html__('Carousel Hover Image', 'kudos'),
                'description' => esc_html__('Choose carousel hover image (min width needs to be 215px)', 'kudos'),
                'parent' => $carousel_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_carousel_item_link',
                'type' => 'text',
                'label' => esc_html__('Link', 'kudos'),
                'description' => esc_html__('Enter the URL to which you want the image to link to (e.g. http://www.example.com)', 'kudos'),
                'parent' => $carousel_meta_box
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_carousel_item_target',
                'type' => 'selectblank',
                'label' => esc_html__('Target', 'kudos'),
                'description' => esc_html__('Specify where to open the linked document', 'kudos'),
                'parent' => $carousel_meta_box,
                'options' => array(
                    '_self' => esc_html__('Self', 'kudos'),
                    '_blank' => esc_html__('Blank', 'kudos')
                )
            )
        );
    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_carousel');

}