<?php

//Content bottom

if(!function_exists('kudos_qodef_map_content_bottom')) {
    function kudos_qodef_map_content_bottom() {

        $content_bottom_meta_box = kudos_qodef_add_meta_box(
            array(
                'scope' => array('page', 'portfolio-item', 'post'),
                'title' => esc_html__('Content Bottom', 'kudos'),
                'name' => 'content_bottom_meta'
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_enable_content_bottom_area_meta',
                'type' => 'selectblank',
                'default_value' => '',
                'label' => esc_html__('Enable Content Bottom Area', 'kudos'),
                'description' => esc_html__('This option will enable Content Bottom area on pages', 'kudos'),
                'parent' => $content_bottom_meta_box,
                'otions' => array(
                    'no' => esc_html__('No', 'kudos'),
                    'yes' => esc_html__('Yes', 'kudos')
                ),
                'args' => array(
                    'dependence' => true,
                    'hide' => array(
                        '' => '#qodef_qodef_show_content_bottom_meta_container',
                        'no' => '#qodef_qodef_show_content_bottom_meta_container'
                    ),
                    'show' => array(
                        'yes' => '#qodef_qodef_show_content_bottom_meta_container'
                    )
                )
            )
        );

        $show_content_bottom_meta_container = kudos_qodef_add_admin_container(
            array(
                'parent' => $content_bottom_meta_box,
                'name' => 'qodef_show_content_bottom_meta_container',
                'hidden_property' => 'qodef_enable_content_bottom_area_meta',
                'hidden_value' => '',
                'hidden_values' => array('', 'no')
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_content_bottom_sidebar_custom_display_meta',
                'type' => 'selectblank',
                'default_value' => '',
                'label' => esc_html__('Sidebar to Display', 'kudos'),
                'description' => esc_html__('Choose a Content Bottom sidebar to display', 'kudos'),
                'options' => kudos_qodef_get_custom_sidebars(),
                'parent' => $show_content_bottom_meta_container
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'type' => 'selectblank',
                'name' => 'qodef_content_bottom_in_grid_meta',
                'default_value' => '',
                'label' => esc_html__('Display in Grid', 'kudos'),
                'description' => 'Enabling this option will place Content Bottom in grid',
                'otions' => array(
                    'no' => esc_html__('No', 'kudos'),
                    'yes' => esc_html__('Yes', 'kudos')
                ),
                'parent' => $show_content_bottom_meta_container
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'type' => 'color',
                'name' => 'qodef_content_bottom_background_color_meta',
                'default_value' => '',
                'label' => esc_html__('Background Color', 'kudos'),
                'description' => esc_html__('Choose a background color for Content Bottom area', 'kudos'),
                'parent' => $show_content_bottom_meta_container
            )
        );
    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_content_bottom');

}