<?php

/*** Video Post Format ***/

if(!function_exists('kudos_qodef_map_video')) {
    function kudos_qodef_map_video() {

        $video_post_format_meta_box = kudos_qodef_add_meta_box(
            array(
                'scope' => array('post'),
                'title' => esc_html__('Video Post Format', 'kudos'),
                'name' => 'post_format_video_meta'
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_video_type_meta',
                'type' => 'select',
                'label' => esc_html__('Video Type', 'kudos'),
                'description' => esc_html__('Choose video type', 'kudos'),
                'parent' => $video_post_format_meta_box,
                'default_value' => 'social_networks',
                'options' => array(
                    'social_networks' => esc_html__('Youtube or Vimeo', 'kudos'),
                    'self' => esc_html__('Self Hosted', 'kudos')
                ),
                'args' => array(
                    'dependence' => true,
                    'hide' => array(
                        'social_networks' => '#qodef_qodef_video_self_hosted_container',
                        'self' => '#qodef_qodef_video_embedded_container'
                    ),
                    'show' => array(
                        'social_networks' => '#qodef_qodef_video_embedded_container',
                        'self' => '#qodef_qodef_video_self_hosted_container')
                )
            )
        );

        $qodef_video_embedded_container = kudos_qodef_add_admin_container(
            array(
                'parent' => $video_post_format_meta_box,
                'name' => 'qodef_video_embedded_container',
                'hidden_property' => 'qodef_video_type_meta',
                'hidden_value' => 'self'
            )
        );

        $qodef_video_self_hosted_container = kudos_qodef_add_admin_container(
            array(
                'parent' => $video_post_format_meta_box,
                'name' => 'qodef_video_self_hosted_container',
                'hidden_property' => 'qodef_video_type_meta',
                'hidden_value' => 'social_networks'
            )
        );


        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_post_video_link_meta',
                'type' => 'text',
                'label' => esc_html__('Video URL', 'kudos'),
                'description' => esc_html__('Enter Video URL', 'kudos'),
                'parent' => $qodef_video_embedded_container,

            )
        );


        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_post_video_image_meta',
                'type' => 'image',
                'label' => esc_html__('Video Image', 'kudos'),
                'description' => esc_html__('Upload video image', 'kudos'),
                'parent' => $qodef_video_self_hosted_container,

            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_post_video_webm_link_meta',
                'type' => 'text',
                'label' => esc_html__('Video WEBM', 'kudos'),
                'description' => esc_html__('Enter video URL for WEBM format', 'kudos'),
                'parent' => $qodef_video_self_hosted_container,

            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_post_video_mp4_link_meta',
                'type' => 'text',
                'label' => esc_html__('Video MP4', 'kudos'),
                'description' => esc_html__('Enter video URL for MP4 format', 'kudos'),
                'parent' => $qodef_video_self_hosted_container,

            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_post_video_ogv_link_meta',
                'type' => 'text',
                'label' => esc_html__('Video OGV', 'kudos'),
                'description' => esc_html__('Enter video URL for OGV format', 'kudos'),
                'parent' => $qodef_video_self_hosted_container,

            )
        );
    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_video');

}