<?php

//Sidebar

if(!function_exists('kudos_qodef_map_sidebar')) {
    function kudos_qodef_map_sidebar()
    {

        $custom_sidebars = kudos_qodef_get_custom_sidebars();

        $sidebar_meta_box = kudos_qodef_add_meta_box(
            array(
                'scope' => array('page', 'portfolio-item', 'post'),
                'title' => esc_html__('Sidebar', 'kudos'),
                'name' => 'sidebar_meta'
            )
        );

        kudos_qodef_add_meta_box_field(
            array(
                'name' => 'qodef_sidebar_meta',
                'type' => 'select',
                'label' => esc_html__('Layout', 'kudos'),
                'description' => esc_html__('Choose the sidebar layout', 'kudos'),
                'parent' => $sidebar_meta_box,
                'options' => array(
                    '' => 'Default',
                    'no-sidebar' => esc_html__('No Sidebar', 'kudos'),
                    'sidebar-33-right' => esc_html__('Sidebar 1/3 Right', 'kudos'),
                    'sidebar-25-right' => esc_html__('Sidebar 1/4 Right', 'kudos'),
                    'sidebar-33-left' => esc_html__('Sidebar 1/3 Left', 'kudos'),
                    'sidebar-25-left' => esc_html__('Sidebar 1/4 Left', 'kudos'),
                )
            )
        );

        if (count($custom_sidebars) > 0) {
            kudos_qodef_add_meta_box_field(array(
                'name' => 'qodef_custom_sidebar_meta',
                'type' => 'selectblank',
                'label' => esc_html__('Choose Widget Area in Sidebar', 'kudos'),
                'description' => esc_html__('Choose Custom Widget area to display in Sidebar"', 'kudos'),
                'parent' => $sidebar_meta_box,
                'options' => $custom_sidebars
            ));
        }

    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_sidebar');

}
