<?php 
if(!function_exists('kudos_qodef_accordions_map')) {
    /**
     * Add Accordion options to elements panel
     */
   function kudos_qodef_accordions_map() {
		
       $panel = kudos_qodef_add_admin_panel(array(
           'title' => esc_html__('Accordions', 'kudos'),
           'name'  => 'panel_accordions',
           'page'  => '_elements_page'
       ));

       //Typography options
       kudos_qodef_add_admin_section_title(array(
           'name' => 'typography_section_title',
           'title' => esc_html__('Typography', 'kudos'),
           'parent' => $panel
       ));

       $typography_group = kudos_qodef_add_admin_group(array(
           'name' => 'typography_group',
           'title' => esc_html__('Typography', 'kudos'),
			'description' => esc_html__('Setup typography for accordions navigation', 'kudos'),
           'parent' => $panel
       ));

       $typography_row = kudos_qodef_add_admin_row(array(
           'name' => 'typography_row',
           'next' => true,
           'parent' => $typography_group
       ));

       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row,
           'type'          => 'fontsimple',
           'name'          => 'accordions_font_family',
           'default_value' => '',
           'label'         => esc_html__('Font Family', 'kudos'),
       ));

       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row,
           'type'          => 'selectsimple',
           'name'          => 'accordions_text_transform',
           'default_value' => '',
           'label'         => esc_html__('Text Transform', 'kudos'),
           'options'       => kudos_qodef_get_text_transform_array()
       ));

       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row,
           'type'          => 'selectsimple',
           'name'          => 'accordions_font_style',
           'default_value' => '',
           'label'         => esc_html__('Font Style', 'kudos'),
           'options'       => kudos_qodef_get_font_style_array()
       ));

       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row,
           'type'          => 'textsimple',
           'name'          => 'accordions_letter_spacing',
           'default_value' => '',
           'label'         => esc_html__('Letter Spacing', 'kudos'),
           'args'          => array(
               'suffix' => 'px'
           )
       ));

       $typography_row2 = kudos_qodef_add_admin_row(array(
           'name' => 'typography_row2',
           'next' => true,
           'parent' => $typography_group
       ));		
		
       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row2,
           'type'          => 'selectsimple',
           'name'          => 'accordions_font_weight',
           'default_value' => '',
           'label'         => esc_html__('Font Weight', 'kudos'),
           'options'       => kudos_qodef_get_font_weight_array()
       ));

       kudos_qodef_add_admin_field(array(
           'parent'        => $typography_row2,
           'type'          => 'textsimple',
           'name'          => 'accordions_font_size',
           'default_value' => '',
           'label'         => esc_html__('Font Size', 'kudos'),
           'args'          => array(
               'suffix' => 'px'
           )
       ));

		//Initial Accordion Color Styles
		
		kudos_qodef_add_admin_section_title(array(
           'name' => 'accordion_color_section_title',
           'title' => esc_html__('Accordions Color Styles', 'kudos'),
           'parent' => $panel
        ));
		
		$accordions_color_group = kudos_qodef_add_admin_group(array(
           'name' => 'accordions_color_group',
           'title' => esc_html__('Accordion Title Color Styles', 'kudos'),
			'description' => esc_html__('Set color styles for accordion title', 'kudos'),
           'parent' => $panel
        ));
		$accordions_color_row = kudos_qodef_add_admin_row(array(
           'name' => 'accordions_color_row',
           'next' => true,
           'parent' => $accordions_color_group
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_title_color',
           'default_value' => '',
           'label'         => esc_html__('Title Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_title_background_color',
           'default_value' => '',
           'label'         => esc_html__('Title Background Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_icon_color',
           'default_value' => '',
           'label'         => esc_html__('Icon Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_icon_back_color',
           'default_value' => '',
           'label'         => esc_html__('Icon Background Color', 'kudos')
        ));

       //Active Accordion Color Styles
		
		$active_accordions_color_group = kudos_qodef_add_admin_group(array(
           'name' => 'active_accordions_color_group',
           'title' => esc_html__('Active and Hover Accordion Title Color Styles', 'kudos'),
			'description' => esc_html__('Set color styles for active and hover accordions title', 'kudos'),
           'parent' => $panel
        ));
		$active_accordions_color_row = kudos_qodef_add_admin_row(array(
           'name' => 'active_accordions_color_row',
           'next' => true,
           'parent' => $active_accordions_color_group
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $active_accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_title_color_active',
           'default_value' => '',
           'label'         => esc_html__('Title Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $active_accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_title_background_color_active',
           'default_value' => '',
           'label'         => 'Title Background Color'
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $active_accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_icon_color_active',
           'default_value' => '',
           'label'         => esc_html__('Icon Color', 'kudos')
        ));
        kudos_qodef_add_admin_field(array(
           'parent'        => $active_accordions_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_icon_back_color_active',
           'default_value' => '',
           'label'         => esc_html__('Icon Background Color', 'kudos')
        ));

       //Content color styles

       $accordions_content_color_group = kudos_qodef_add_admin_group(array(
           'name' => 'accordions_content_color_group',
           'title' => esc_html__('Accordion Content Color Styles', 'kudos'),
           'description' => esc_html__('Set color styles for accordions content', 'kudos'),
           'parent' => $panel
       ));
       $accordions_content_color_row = kudos_qodef_add_admin_row(array(
           'name' => 'accordions_content_color_row',
           'next' => true,
           'parent' => $accordions_content_color_group
       ));
       kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_content_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_content_background_color',
           'default_value' => '',
           'label'         => esc_html__('Content Background Color', 'kudos')
       ));
       kudos_qodef_add_admin_field(array(
           'parent'        => $accordions_content_color_row,
           'type'          => 'colorsimple',
           'name'          => 'accordions_content_color',
           'default_value' => '',
           'label'         => esc_html__('Content Text Color', 'kudos')
       ));
       
   }
   add_action('kudos_qodef_options_elements_map', 'kudos_qodef_accordions_map');
}