<?php
namespace KudosQodef\Modules\Shortcodes\VerticalSplitSliderRightPanel;

use KudosQodef\Modules\Shortcodes\Lib\ShortcodeInterface;

/**
 * Class Vertical Split Slider
 */
class VerticalSplitSliderRightPanel implements ShortcodeInterface{
	private $base; 
	
	function __construct() {
		$this->base = 'qodef_vertical_split_slider_right_panel';

		add_action('vc_before_init', array($this, 'vcMap'));
	}
	
	/**
		* Returns base for shortcode
		* @return string
	 */

	public function getBase() {
		return $this->base;
	}

	public function vcMap() {
		if(function_exists('vc_map')){
			vc_map(
				array(
					'name' => esc_html__('Select Vertical Split Slider Right Panel', 'kudos'),
					'base' => $this->base,
					'category' => 'by SELECT',
					'icon' => 'icon-wpb-vertical-split-slider-right extended-custom-icon',
					'as_parent' => array('only' => 'qodef_vertical_split_slider_item'),
					'as_child' => array('only' => 'qodef_vertical_split_slider'),
					'js_view' => 'VcColumnView',
                    'show_settings_on_create' => false,
					'params' => array()
				)
			);
		}
	}

	public function render($atts, $content = null) {
		
		$args = array();

		$params = shortcode_atts($args, $atts);

        extract($params);

        $html = '';

        $html .= '<div class="qodef-vertical-split-slider-panel qodef-vertical-split-slider-right-panel ms-right">';
            $html .= do_shortcode($content);
        $html .= '</div>';

        return $html;

	}

}